/*
 * (c) Copyright 2015 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef DNGREF_H_
#define DNGREF_H_

#include <profio.h>

// XYZ D50 to Prophoto RGB, according to DNG SDK reference code
extern const m3x3 dcp_xyz_D50_to_prophoto_rgb;

m3x3
dcp_map_white(const v3 white1_xyz,
              const v3 white2_xyz);

v3
dcp_rgb2hsv(v3 rgb);

v3
dcp_hsv2rgb(const v3 hsv);

v3
dcp_lookup(const v3 *hsm,
           const uint32_t hsmdims[3],
           const bool srgb_gamma,
           const v3 cxyz);

void
dcp_neutral2xy(const struct profio_dcp *dcp,
               v3 neutral,
               double xy[2]);

m3x3
dcp_make_cam2xyz_d50(const struct profio_dcp *dcp,
                     const v3 wb);

v3 *
dcp_make_lut(const struct profio_dcp *dcp,
             const v3 wb);

v3
dcp_d50(void);

#endif
