/*
 * (c) Copyright 2015 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef JSONIO_H_
#define JSONIO_H_

#include <stdbool.h>

#include <spectrum.h>
#include <colmath.h>
#include <profio.h>
#include <dcamprof.h>

struct dcam_ssf *
jsonio_dcam_ssf_parse(const char filename[],
                      bool parse_error_is_fatal);

spectrum_t *
jsonio_spectrum_parse(const char filename[],
                      bool parse_error_is_fatal);

void
jsonio_spectrum_print(FILE *stream,
                      const char indent[],
                      const char name[],
                      const spectrum_t *s);

spectrum_t *
jsonio_illuminant_parse(const char filename[],
                        bool parse_error_is_fatal);

m3x3 *
jsonio_3x3matrix_parse(const char filename[],
                       const char optional_matrix_name[],
                       bool parse_error_is_fatal);

void
jsonio_3x3matrix_print(FILE *stream,
                       const char indent[],
                       const char name[],
                       m3x3 m);

struct profio_dcp *
jsonio_dcp_parse(const char filename[],
                 bool parse_error_is_fatal);

struct dcam_profile *
jsonio_profile_parse(const char filename[],
                     bool parse_error_is_fatal);



#endif
